﻿using System;
using System.Collections;
namespace ObjectCache.Ejm1
{
    /// <summary>
    /// Representa items recientemente activados: los ultimos 5
    /// </summary>
    public class ItemCache
    {
        private const int MaxCacheSize = 5;
        ArrayList cache;

        public ItemCache()
        {
            cache = new ArrayList();
        }
        /// <summary>
        /// Busca un item en el cache
        /// </summary>
        /// <param name="code">Codigo de barras</param>
        /// <returns>El item</returns>
        public string GetItem(string code)
        {
            string barCode = null;
            int pos = cache.IndexOf(code);
            if (pos != -1)
                barCode = cache[pos] as string; ;
            return barCode;
        }
        /// <summary>
        /// Agrega un item al cache
        /// </summary>
        /// <param name="code"></param>
        public void AddItem(string code)
        {
            //if the max limit is reached
            //remove the LRU item
            
            if (cache.Count == MaxCacheSize)
            {
                //Remueve el primero del cache, por ser más antiguo
                cache.RemoveAt(0);
            }
            cache.Add(code);
        }
    }
}
